package givicenc;
import iic2132.*;

/**
 * Position              <br>
 * Extended by givicenc  <br><br>
 * 
 * - Cada position es como un "Node" o Vertex de un grafo                     <br>
 * - Guarda lista con adyacentes (inicialmente son 8 pero vamos descartando)  <br>
 * - Guarda nmero de visitas: Visits                                         <br>
 * - Guarda direccion del goal desde ahi                                      <br>
 * - Guarda el contenido: World.GOAL, World.OBSTACLE, World.EMPTY             <br>
 * - Guarda si est pintado como parte del path al goal: IsInGoalPath         <br>
 * - Guarda un Set, que es como el representante en un conjunto disjunto.     <br>
 */

public class Position {
	
	public int Row;
	public int Col;
	
	//--------------------------------------------------------------
	
	private char _content;
	
	public int Visits;
	public int GoalDirection;
	public boolean IsInGoalPath;
	
	//--------------------------------------------------------------
	
	public Position(int row, int col) {
		this.Row = row;
		this.Col = col;

		this._content = World.UNKNOWN;
		this.Visits = 0;
		this.IsInGoalPath = false;
		
	}
		
	//--------------------------------------------------------------
	
	/**
	 *  Le cambia su _content
	 **/
	public void SetContent(char content) 
	{
		_content = content;
	}
	
	//--------------------------------------------------------------
	
	public char GetContent() 
	{
		return _content;
	}
	
	//--------------------------------------------------------------
	
	public boolean Visited() 
	{
		return (this.Visits > 0);
	}

	//--------------------------------------------------------------
	
	public boolean Unvisited() 
	{
		return (this.Visits == 0);
	}
	
	//--------------------------------------------------------------
	
	public boolean IsGoal() 
	{
		return this.GetContent() == World.GOAL;
	}
	
	//--------------------------------------------------------------
	
	public boolean IsObstacle() 
	{
		return this.GetContent() == World.OBSTACLE;
	}
	
	//--------------------------------------------------------------
	
	public boolean IsEmpty() 
	{
		return this.GetContent() == World.EMPTY;
	}
	
	//--------------------------------------------------------------
}
