package iic2132;

import java.io.IOException;


/**
 * @author dimatura
 *
 */
public class t3main {
	static final int DEFAULT_MAX_STEPS = 10000;
	static final int DEFAULT_DELAY_MS = 40;
	
	public static void main(String[] args) {		
		if (args.length != 2) {
			System.err.println("Usage: t3main MAP NAVIGATOR_CLASS");
			return;
		}
		WorldLoader builder = new WorldLoader();
		try {
			World maze = builder.build(args[0]);
			//maze.print(System.out);
			INavigator nav = (INavigator) Class.forName(args[1]).newInstance();
			//Simulator sim = new Simulator(nav, maze);
			GSimulator sim = new GSimulator(nav, maze);
			double pathLength = sim.go(DEFAULT_MAX_STEPS, DEFAULT_DELAY_MS);
			System.out.println("Path length: "+pathLength);
		} catch (IOException ex) {
			System.err.println(ex);			
		} catch (WorldLoaderException ex) {
			System.err.println(ex);			
		} catch (IllegalAccessException ex) {
			System.err.println(ex);			
		} catch (InstantiationException ex) {
			System.err.println(ex);
		} catch (ClassNotFoundException ex) {
			System.err.println(ex);
		}
	}
}
